%define major   %{version}
%define libname %mklibname rttr_core %{major}
%define devname %mklibname rttr -d

Name:           rttr
Version:        0.9.6
Release:        %mkrel 1
Summary:        Run Time Type Reflection for C++
License:        MIT
Group:          System/Libraries
URL:            https://github.com/rttrorg/rttr
Source0:        https://github.com/rttrorg/rttr/releases/download/v%{version}/%{name}-%{version}-src.tar.xz
# fix cmake installation directories
Patch1:         cmake_install_dir.patch
# remove date and time information from generated documentation
Patch2:         doxygen_remove_date_time.patch
# fix compile error (https://github.com/rttrorg/rttr/issues/224)
Patch3:         skip_json_example.patch
# fix wrong permissions of headers (https://github.com/rttrorg/rttr/issues/147)
Patch4:         fix-include-permissions.patch
BuildRequires:  cmake
BuildRequires:  dos2unix
BuildRequires:  doxygen
BuildRequires:  gcc-c++

%description
Run Time Type Reflection is the the ability of a computer program to
introspect and modify objects at runtime. It is also the name of the
library itself, which is written in C++.

#------------------------------------------------

%package -n     %{libname}
Summary:        Run Time Type Reflection for C++
Group:          System/Libraries

%description -n %{libname}
Run Time Type Reflection is the the ability of a computer program to
introspect and modify objects at runtime. It is also the name of the
library itself, which is written in C++.

%files -n %{libname}
%{_libdir}/librttr_core.so.%{major}

#------------------------------------------------

%package -n     %{devname}
Summary:        Development package for %{name}
Group:          Development/Libraries
Requires:       %{libname} = %{version}-%{release}
Provides:       %{name}-devel = %{version}-%{release}

%description -n %{devname}
Header files for development with %{name}.

%files -n %{devname}
%{_docdir}/rttr/
%{_includedir}/rttr/
%{_libdir}/librttr_core.so
%{_libdir}/cmake/rttr/

#------------------------------------------------

%prep
%setup -q
%apply_patches

find . -type f -exec chmod a-x "{}" +
dos2unix README.md

%build
%cmake -DBUILD_BENCHMARKS=OFF \
       -DBUILD_UNIT_TESTS=OFF \
       -DBUILD_PACKAGE=OFF

%cmake_build

%install
%cmake_install rttr_core

rm -Rf %{buildroot}%{_datadir}/rttr


%changelog
* Sat Feb 15 2020 tex - 0.9.6-1pclos2020
- initial package rttr

